SHCNE_RENAMEITEM       	equ 00000001h
SHCNE_CREATE	       	equ 00000002h
SHCNE_DELETE	       	equ 00000004h
SHCNE_MKDIR	           	equ 00000008h
SHCNE_RMDIR             equ 00000010h
SHCNE_MEDIAINSERTED     equ 00000020h
SHCNE_MEDIAREMOVED      equ 00000040h
SHCNE_DRIVEREMOVED      equ 00000080h
SHCNE_DRIVEADD          equ 00000100h
SHCNE_NETSHARE          equ 00000200h
SHCNE_NETUNSHARE        equ 00000400h
SHCNE_ATTRIBUTES        equ 00000800h
SHCNE_UPDATEDIR         equ 00001000h
SHCNE_UPDATEITEM       	equ 00002000h
SHCNE_SERVERDISCONNECT 	equ 00004000h
SHCNE_UPDATEIMAGE       equ 00008000h
SHCNE_DRIVEADDGUI       equ 00010000h
SHCNE_RENAMEFOLDER      equ 00020000h
SHCNE_FREESPACE         equ 00040000h
SHCNE_ASSOCCHANGED      equ 08000000h
SHCNE_DISKEVENTS        equ 0002381Fh
SHCNE_GLOBALEVENTS      equ 0C0581E0h 
SHCNE_ALLEVENTS         equ 7FFFFFFFh
SHCNE_INTERRUPT         equ 80000000h 
                                          
SHCNF_IDLIST      		equ 0000h	
SHCNF_PATH        		equ 0001h	
SHCNF_PRINTER     		equ 0002h	
SHCNF_DWORD       		equ 0003h
SHCNF_TYPE        		equ 00FFh
SHCNF_FLUSH       		equ 1000h
SHCNF_FLUSHNOWAIT 		equ 2000h

SHARD_PIDL				equ	00000001h
SHARD_PATH     			equ	00000002h


; Shell Functions
;-------------------------------------------------------------------------------------------------

SHGetMalloc PROTO :DWORD
SHGetPathFromIDList PROTO :DWORD, :DWORD
SHGetSpecialFolderLocation PROTO :DWORD, :DWORD, :DWORD
SHBrowseForFolder PROTO :DWORD
SHLoadInProc PROTO :DWORD
SHGetDesktopFolder PROTO STDCALL :DWORD
SHChangeNotify PROTO :DWORD, :DWORD, :DWORD, :DWORD
SHAddToRecentDocs PROTO :DWORD, :DWORD
SHGetInstanceExplorer PROTO :DWORD
SHGetFileInfo PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD


SHGDN_NORMAL	    	equ 0
SHGDN_INFOLDER          equ 1      
SHGDN_FORPARSING	    equ 8000h  

SHCONTF_FOLDERS         equ 32
SHCONTF_NONFOLDERS      equ 64
SHCONTF_INCLUDEHIDDEN   equ 128	

SFGAO_CANCOPY           equ DROPEFFECT_COPY 
SFGAO_CANMOVE           equ DROPEFFECT_MOVE
SFGAO_CANLINK           equ DROPEFFECT_LINK 
SFGAO_CANRENAME         equ 00000010h     
SFGAO_CANDELETE         equ 00000020h     
SFGAO_HASPROPSHEET      equ 00000040h    
SFGAO_DROPTARGET		equ 00000100h
SFGAO_CAPABILITYMASK    equ 00000177h
SFGAO_LINK              equ 00010000h
SFGAO_SHARE             equ 00020000h
SFGAO_READONLY          equ 00040000h 
SFGAO_GHOSTED           equ 00080000h  
SFGAO_DISPLAYATTRMASK   equ 000F0000h
SFGAO_FILESYSANCESTOR   equ 10000000h    
SFGAO_FOLDER            equ 20000000h     
SFGAO_FILESYSTEM        equ 40000000h     
SFGAO_HASSUBFOLDER      equ 80000000h     
SFGAO_CONTENTSMASK      equ 80000000h
SFGAO_VALIDATE          equ 01000000h    
SFGAO_REMOVABLE         equ 02000000h    

; IShellFolder
;-------------------------------------------------------------------------------------------------

SHGDN_NORMAL	    	equ 0
SHGDN_INFOLDER          equ 1      
SHGDN_FORPARSING	    equ 8000h  

SHCONTF_FOLDERS         equ 32
SHCONTF_NONFOLDERS      equ 64
SHCONTF_INCLUDEHIDDEN   equ 128	

SFGAO_CANCOPY           equ DROPEFFECT_COPY 
SFGAO_CANMOVE           equ DROPEFFECT_MOVE
SFGAO_CANLINK           equ DROPEFFECT_LINK 
SFGAO_CANRENAME         equ 00000010h     
SFGAO_CANDELETE         equ 00000020h     
SFGAO_HASPROPSHEET      equ 00000040h    
SFGAO_DROPTARGET		equ 00000100h
SFGAO_CAPABILITYMASK    equ 00000177h
SFGAO_LINK              equ 00010000h
SFGAO_SHARE             equ 00020000h
SFGAO_READONLY          equ 00040000h 
SFGAO_GHOSTED           equ 00080000h  
SFGAO_DISPLAYATTRMASK   equ 000F0000h
SFGAO_FILESYSANCESTOR   equ 10000000h    
SFGAO_FOLDER            equ 20000000h     
SFGAO_FILESYSTEM        equ 40000000h     
SFGAO_HASSUBFOLDER      equ 80000000h     
SFGAO_CONTENTSMASK      equ 80000000h
SFGAO_VALIDATE          equ 01000000h    
SFGAO_REMOVABLE         equ 02000000h    

LPENUMIDLIST			typedef DWORD
LPPENUMIDLIST			typedef PTR LPENUMIDLIST
LPITEMIDLIST	typedef PTR ITEMIDLIST
LPPITEMIDLIST	typedef PTR LPITEMIDLIST
LPSHITEMID		typedef	PTR SHITEMID   
LPSTRRET		typedef PTR STRRET
LPSHELLFOLDER						typedef DWORD
LPPSHELLFOLDER						typedef DWORD
pcomethod1   TYPEDEF PROTO :DWORD
pcomethod2   TYPEDEF PROTO :DWORD, :DWORD
pcomethod3   TYPEDEF PROTO :DWORD, :DWORD, :DWORD
pcomethod4   TYPEDEF PROTO :DWORD, :DWORD, :DWORD, :DWORD
pcomethod5   TYPEDEF PROTO :DWORD, :DWORD, :DWORD, :DWORD , :DWORD
pcomethod6   TYPEDEF PROTO :DWORD, :DWORD, :DWORD, :DWORD , :DWORD ,:DWORD
pcomethod7   TYPEDEF PROTO :DWORD, :DWORD, :DWORD, :DWORD , :DWORD ,:DWORD ,:DWORD
pcomethod8   TYPEDEF PROTO :DWORD, :DWORD, :DWORD, :DWORD , :DWORD ,:DWORD ,:DWORD ,:DWORD
pcomethod9   TYPEDEF PROTO :DWORD, :DWORD, :DWORD, :DWORD , :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD
pcomethod10   TYPEDEF PROTO :DWORD, :DWORD, :DWORD, :DWORD , :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD
pcomethod11   TYPEDEF PROTO :DWORD, :DWORD, :DWORD, :DWORD , :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD,:DWORD
pcomethod12   TYPEDEF PROTO :DWORD, :DWORD, :DWORD, :DWORD , :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD,:DWORD,:DWORD
pcomethod13   TYPEDEF PROTO :DWORD, :DWORD, :DWORD, :DWORD , :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD,:DWORD,:DWORD,:DWORD
pcomethod14   TYPEDEF PROTO :DWORD, :DWORD, :DWORD, :DWORD , :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD


comethod1   TYPEDEF PTR pcomethod1
comethod2   TYPEDEF PTR pcomethod2
comethod3   TYPEDEF PTR pcomethod3
comethod4   TYPEDEF PTR pcomethod4
comethod5   TYPEDEF PTR pcomethod5
comethod6   TYPEDEF PTR pcomethod6
comethod7   TYPEDEF PTR pcomethod7
comethod8   TYPEDEF PTR pcomethod8
comethod9   TYPEDEF PTR pcomethod9
comethod10   TYPEDEF PTR pcomethod10
comethod11   TYPEDEF PTR pcomethod11
comethod12   TYPEDEF PTR pcomethod12
comethod13   TYPEDEF PTR pcomethod13
comethod14   TYPEDEF PTR pcomethod14

  STIShellFolder   STRUCT
      QueryInterface                  comethod3 ?
      AddRef                          comethod1 ?
      Release                         comethod1 ?
      ParseDisplayName                comethod7 ?
      EnumObjects1                    comethod4 ?
      BindToObject                    comethod5 ?
      BindToStorage                   comethod5 ?
      CompareIDs                      comethod4 ?
      CreateViewObject                comethod4 ?
      GetAttributesOf                 comethod4 ?
      GetUIObjectOf                   comethod7 ?
      GetDisplayNameOf                comethod4 ?
      SetNameOf                       comethod6 ?
   STIShellFolder   ENDS
   
IShellFolder MACRO  Function:REQ, args:VARARG
   ; definition de la macro locale InvokeInterface
    LOCAL InvokeInterface, arg
    FOR arg, <args>     ;verifier que edx n'est pas dans la liste d'arguments args
        IFIDNI <&arg>, <edx>   ;
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM
    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
   ;InvokeInterface = concatene ...CATSTR(concatene) MACRO instruction MASM32   
   InvokeInterface CATSTR <invoke (STIShellFolder PTR[edx]).>,<&Function,ppvIShellFolder>
    IFNB <args>     ; add the list of parameter arguments if any
        InvokeInterface CATSTR InvokeInterface, <, >, <&args> 
    ENDIF 
   ;   forme les lignes de codes
    mov edx, ppvIShellFolder
    mov edx, [edx]
    InvokeInterface
ENDM      
